#include <netinet/in.h>
#include <netinet/ip.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <unistd.h>

#include <netpacket/packet.h>
#include <net/ethernet.h>
#include <net/if.h>

#define MAXPACKET 65535

void print_ip_info(char *buf, int size);
void pr_iph(struct ip *ip);

void main(void)
{
    int s,size;
    char buf[MAXPACKET];
    struct sockaddr_ll ll;
    
    s=socket(PF_PACKET, SOCK_RAW, ETH_P_IP);
    setuid(getuid());
    
    bzero(&ll, sizeof(ll));
    ll.sll_family=AF_PACKET;
    ll.sll_protocol=htons(ETH_P_IP);
    ll.sll_ifindex=if_nametoindex("eth0");
    if (bind(s, (struct sockaddr *)&ll, sizeof(ll)))
    {
	printf("bind hiba");
	exit(1);
    }
    
    while(1)
    {
	printf(".\n");
	size=recvfrom(s, buf, MAXPACKET, 0,0,0);
	pr_iph((struct ip*)&buf[ETH_HLEN]);
    }
}

void pr_iph(struct ip *ip)
{
	int hlen;
	u_char *cp;

	hlen = ip->ip_hl << 2;
	cp = (u_char *)ip + 20;		/* point to options */

	(void)printf("Vr HL TOS  Len   ID Flg  off TTL Pro  cks      Src      Dst\n");
	(void)printf(" %1x  %1x  %02x %04x %04x",
	    ip->ip_v, ip->ip_hl, ip->ip_tos, ntohs(ip->ip_len),
	    ntohs(ip->ip_id));
	(void)printf("   %1lx %04lx",
	    (u_long) (ntohl(ip->ip_off) & 0xe000) >> 13,
	    (u_long) ntohl(ip->ip_off) & 0x1fff);
	(void)printf("  %02x  %02x %04x", ip->ip_ttl, ip->ip_p,
							    ntohs(ip->ip_sum));
	(void)printf(" %s ", inet_ntoa(*(struct in_addr *)&ip->ip_src.s_addr));
	(void)printf(" %s ", inet_ntoa(*(struct in_addr *)&ip->ip_dst.s_addr));
	/* dump any option bytes */
	while (hlen-- > 20) {
		(void)printf("%02x", *cp++);
	}
	(void)putchar('\n');
}
