#include <netinet/in.h>
#include <netinet/ip.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <unistd.h>

#define MAXPACKET 65535
char packet[MAXPACKET];

void icmp_print(char *packet, int size);
void tcp_print(char *packet, int size);
void udp_print(char *packet, int size);
void pr_iph(struct ip *ip);

void main(void)
{
    fd_set readset,temp;
    int rawtcp, rawudp, rawicmp;
    int r,s;

    /*A socketek ltrehozsa, ahonnan majd olvasunk*/
    rawicmp=socket(AF_INET, SOCK_RAW, IPPROTO_ICMP);
    rawtcp=socket(AF_INET, SOCK_RAW, IPPROTO_TCP);
    rawudp=socket(AF_INET, SOCK_RAW, IPPROTO_UDP);

    while(1)
    {
        FD_ZERO(&readset);
        FD_SET(rawicmp,&readset);
        FD_SET(rawtcp,&readset);
        FD_SET(rawudp,&readset);
	r=select(FD_SETSIZE,  &readset, NULL, NULL, NULL);
	if (r>=0)
	{
		if (FD_ISSET(rawicmp, &readset))
		{
		    s=read(rawicmp, packet, MAXPACKET);
		    icmp_print(packet,s);
		}
		if (FD_ISSET(rawtcp, &readset))
		{
		    s=read(rawtcp, packet, MAXPACKET);
		    tcp_print(packet,s);
		}
		if (FD_ISSET(rawudp, &readset))
		{
		    s=read(rawudp, packet, MAXPACKET);
		    udp_print(packet,s);
		}
	}
    }
}

void icmp_print(char *packet, int size)
{
    printf("icmp packet:\n");
    pr_iph((struct ip*)packet);
}

void tcp_print(char *packet, int size)
{
    printf("tcp packet:\n");
    pr_iph((struct ip*)packet);
}

void udp_print(char *packet, int size)
{
    printf("udp packet:\n");
    pr_iph((struct ip*)packet);
}

/*
 * IP header cuccainak kiirasa
 * PING.C -bol lopva
 */

void pr_iph(struct ip *ip)
{
	int hlen;
	u_char *cp;

	hlen = ip->ip_hl << 2;
	cp = (u_char *)ip + 20;		/* point to options */

	(void)printf("Vr HL TOS  Len   ID Flg  off TTL Pro  cks      Src      Dst\n");
	(void)printf(" %1x  %1x  %02x %04x %04x",
	    ip->ip_v, ip->ip_hl, ip->ip_tos, ntohs(ip->ip_len),
	    ntohs(ip->ip_id));
	(void)printf("   %1lx %04lx",
	    (u_long) (ntohl(ip->ip_off) & 0xe000) >> 13,
	    (u_long) ntohl(ip->ip_off) & 0x1fff);
	(void)printf("  %02x  %02x %04x", ip->ip_ttl, ip->ip_p,
							    ntohs(ip->ip_sum));
	(void)printf(" %s ", inet_ntoa(*(struct in_addr *)&ip->ip_src.s_addr));
	(void)printf(" %s ", inet_ntoa(*(struct in_addr *)&ip->ip_dst.s_addr));
	/* dump any option bytes */
	while (hlen-- > 20) {
		(void)printf("%02x", *cp++);
	}
	(void)putchar('\n');
}
